%% cycles.pl : funcions per tractament de cicles  (03-09-02)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  USES: prec_stat,list,a_intrpo,int_rpo
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% set_Int_cycles(Ccycles,Crules,CrulesOut,LInts,LIntsOut,LIntsfix,LIntsfixOut,
%					Prec,PrecOut,Stat,StatOut).
% obt_set_cycles(Ccycles,Symbs,SymbsOut,Cset,RestCcycles)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%retorna: 
% [ [llista_symbols1,const11,const12,...], [llista_symbols2,const21,const22,...]...]
obtain_set_cycles([],Symbs,Symbs,[],[]):-!.
obtain_set_cycles([Const|LConst],[],SymbsOut,[Const|Cset],RestCcycles):-!,
	Const=..[_|[L,R]], L=..[F|_], R=..[G|_],
	addifno(G,[F],Symbs),
	obtain_set_cycles(LConst,Symbs,SymbsOut,Cset,RestCcycles),!.
obtain_set_cycles([Const|LConst],Symbs,SymbsOut,[Const|Cset],RestCcycles):-
	Const=..[_|[L,R]], L=..[F|_], R=..[G|_],
	((member212(F,Symbs),addifno(G,Symbs,Symbs1));
		(member212(G,Symbs),addifno(F,Symbs,Symbs1))),!,
	obtain_set_cycles(LConst,Symbs1,SymbsOut,Cset,RestCcycles),!.
obtain_set_cycles([Const|LConst],Symbs,SymbsOut,Cset,[Const|RestCcycles]):-
	obtain_set_cycles(LConst,Symbs,SymbsOut,Cset,RestCcycles),!.


obt_set_cycles(Ccycles,Symbs,SymbsOut,Cset,RestCcycles):-
	obtain_set_cycles(Ccycles,Symbs,Symbs1,Cset1,Rest1),
	obt_set_cycles1(Symbs,Symbs1,SymbsOut,Cset1,Cset,Rest1,RestCcycles).

obt_set_cycles1(Symbs,Symbs,Symbs,Cset,Cset,Rest,Rest):-!.
obt_set_cycles1(_,Symbs1,Symbs1,Cset,Cset,[],[]):-!.
obt_set_cycles1(_,Symbs1,SymbsOut,Cset1,CsetOut,Rest1,RestOut):-
	obt_set_cycles(Rest1,Symbs1,SymbsOut,Cset2,RestOut),
	concat312(Cset1,Cset2,CsetOut),!.	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
set_Int_cycles(Ccycles,Crules,CrulesOut,LInts,LIntsOut,LIntsfix,LIntsfixOut,
					Prec,PrecOut,Stat,StatOut):-
	Ccycles=[_|_],
	obt_set_cycles(Ccycles,[],Symbs,Cset,RestCcycles),
   	map(head,LIntsfix,Symbsfixed),
   	difer(Symbs,Symbsfixed,Symbstofix),!, 
	set_Int_1cycle(Symbstofix,Cset,Crules,Crules1,RestCcycles,Ccycles1,
		LInts,LInts1,LIntsfix,LIntsfix1,Prec,Stat,Prec1,Stat1),
	set_int_leftisvar2(Crules1,Ccycles1,LInts1,LIntsfix1,
   		Crules2,Ccycles2,LInts2,LIntsfix2,Prec1,Stat1,Prec2,Stat2),
   	set_Int_cycles(Ccycles2,Crules2,CrulesOut,LInts2,LIntsOut,
			LIntsfix2,LIntsfixOut,Prec2,PrecOut,Stat2,StatOut).
set_Int_cycles([],Crules,Crules,LInts,LInts,LIntsfix,LIntsfix,P,P,S,S).


set_Int_1cycle([],Cset,Crules,CrulesOut,RestCcycles,RestCcycles,
				LInts,LInts,LIntsfix,LIntsfix,P,S,P,S):-!,
   	concat312(Crules,Cset,CrulesOut),!.
set_Int_1cycle(Symbs,Cset,Crules,CrulesOut,RestCcycles,CcyclesOut,
		LInts,LIntsOut,LIntsfix,LIntsfixOut,Prec,Stat,PrecOut,StatOut):-
	simp_ints_set(Symbs,LInts,LInts1,Prec),!,
 	fix_int_set(Symbs,Crules,Cset,LInts1,LInts11,Prec,Stat),
	concat312(Crules,Cset,Crules1),
	simplify_and_check2(Crules1,RestCcycles,LInts11,LIntsfix,
 	     CrulesOut,CcyclesOut,LIntsOut,LIntsfixOut,Prec,Stat,PrecOut,StatOut).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% conjunt amb un nic smbol
simp_ints_set(L,LInts1,LInts2,Prec):-
	all_ig_prec(L,Prec),!,
	remove_head1sub(L,LInts1,LInts2),!.
simp_ints_set(_,LInts1,LInts1,_):-!.

% elimina les interpretacions amb head+1subterm

remove_head1sub([],LInts,LInts):-!.
remove_head1sub([F|Rest],LInts,LIntsOut):-
	delete32([F,Ar,IntsF],LInts,LInts1),!,
	remove_h1s(IntsF,IntsF1),!,\+(IntsF1=[]),
	remove_head1sub(Rest,[[F,Ar,IntsF1]|LInts1],LIntsOut),!.
		
remove_h1s([],[]).
remove_h1s([[1|R]|RInts],RInts1):- 
	sum(R,1),!,
	remove_h1s(RInts,RInts1).
remove_h1s([Int|RInts],[Int|RInts1]):-
	remove_h1s(RInts,RInts1),!.

all_ig_prec([],_):-!.
all_ig_prec([_],_):-!.
all_ig_prec([F,G|L],Prec):-
	igual(F,G,Prec),!,
	all_ig_prec([G|L],Prec),!.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fix_int_set([],_,_,LInts,LInts,_,_):-!.
fix_int_set([F|Lsym],CRules,Cset,LInts,LIntsOut,Prec,Stat):-
	delete32([F,Ar,LIntsF],LInts,LInts1),!,
	sort(LIntsF,LIntsFord),
	concat312(CRules,Cset,CConst),!,
	member22(IntF,LIntsFord),
	simplify_Ints_vars_Sat(CConst,[[F,Ar,[IntF]]|LInts1],LInts2),
	interpret(Cset,[[F,Ar,IntF]],[],Cset1),
	check_rules(Cset1,LInts2,Prec,Stat,[],Cset2),
	fix_int_set(Lsym,CRules,Cset2,LInts2,LIntsOut,Prec,Stat).
fix_int_set([_|Lsym],CRules,Cset,LInts,LIntsOut,Prec,Stat):-
	%el smbol ha pres una interpretaci per defecte
	fix_int_set(Lsym,CRules,Cset,LInts,LIntsOut,Prec,Stat).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
